#!/usr/bin/python

##############################################################
#                                                            #
#                       MyAuction	V2.6 	             #
#                                                            #
#   Copyright: Andreas Brandmaier (andy@brandmaier.de)       #
#   License:  GPL                                            #
#   A superkaramba theme for watching eBay auctions          #
#                                                            #
##############################################################



#
#	DO NOT CHANGE THIS FILE
#	any configurations can made in graphical, interactive menus
#	right-click on MyAuction -> Configure Theme



# Imports
import karamba
import re
import string
import sys
import htmlentitydefs
from urllib import urlopen, quote_plus

# list

itemlistindex = 0
itemlist = []

# Localization

locales_text = ['Ebay.de [Germany]','Ebay.com [USA]','Ebay.co.uk [GB]', 'Ebay.it [IT]','Ebay.fr [FR]', 'Allegro.pl [PL]']
locales = ['de','us','uk','it','fr', 'pl']
locale = 'us'

# Color Schemes

schemeindex = 0

schemes = []
schemes.append([[0,0,0],[0,0,255]])
schemes.append([[255,255,255],[255,0,0]])
schemes.append([[200,200,200],[255,255,255]])
schemes.append([[60,60,60],[0,0,0]])
schemes.append([[0,0,0],[0,200,0]])

schemes_text = ['AlphaBlue','AlphaRed','White','Black','AlphaGreen']	

# Init
menu_add_id = 0
menu_remove_id = 0    
menu_background_id = 0
menu_color_id = 0
menu_changelanguage_id = 0

# Meters
label_title=0
label_price=0
label_duration=0
meter_title=0
meter_price=0
meter_duration=0

#sys.setdefaultencoding('iso-8859-1')

	
#this is called when you widget is initialized
def initWidget(widget):




	readConfiguration(widget)
	createLayout(widget)
	initLocales(widget)	
	
	# references

	star = karamba.getThemeImage(widget,"star")
	down = karamba.getThemeImage(widget,"down")
	load = karamba.getThemeImage(widget,"load")
	up = karamba.getThemeImage(widget,"up")

	# clickarea
	karamba.attachClickArea(widget,star)
	karamba.attachClickArea(widget,down)
	karamba.attachClickArea(widget,load)
	karamba.attachClickArea(widget,up)
	karamba.attachClickArea(widget,meter_title)
	
	karamba.addImageTooltip(widget, down, lc_help_cycleback)
	karamba.addImageTooltip(widget, load, lc_help_load)
	karamba.addImageTooltip(widget, up, lc_help_cycle)

	createConfigurationMenu(widget)
	
	# initial update
	reloadData(widget)
	


def mySetMenuConfigOption(widget, key, value):

	try:
		karamba.setMenuConfigOption(widget, key, value)
	except:
		karamba.setMenuConfigOption(widget, key, str(value) )

	

def createConfigurationMenu(widget):
		
	##karamba.addMenuConfigOption(widget, "background", "Change the background")
	##karamba.setMenuConfigOption(widget, "background", 0)
	karamba.addMenuConfigOption(widget, "changelanguage", lc_menu_changelanguage)
	mySetMenuConfigOption(widget, "changelanguage", 0)
	karamba.addMenuConfigOption(widget, "add", lc_menu_addauction)
	mySetMenuConfigOption(widget, "add", 0)
	karamba.addMenuConfigOption(widget, "remove", lc_menu_removeauction)
	mySetMenuConfigOption(widget, "remove", 0)
	karamba.addMenuConfigOption(widget, "colorscheme", lc_menu_colorscheme)
	mySetMenuConfigOption(widget, "colorscheme", 0)


def menuOptionChanged(widget, key, value):

	global itemlist, menu_background_id, menu_add_id, menu_remove_id, menu_changelanguage_id, menu_colorscheme_id

	if key == "background":
		mySetMenuConfigOption(widget, "background", 0)
		print key
		print "clicked\n"
	
	if key == "add":
		mySetMenuConfigOption(widget, "add", 0)
		menu_add_id = karamba.executeInteractive(widget, ["kdialog", "--title", lc_dialog_addauction_title, "--inputbox", lc_dialog_addauction_text])
		
	if key == "remove":
		mySetMenuConfigOption(widget, "remove", 0)
		remcommand = ["kdialog", "--title", lc_dialog_removeauction_title, "--radiolist", lc_dialog_removeauction_title]
        	for i in range(len(itemlist)):
        		remcommand.append(str(i))
        		remcommand.append(itemlist[i])
        		remcommand.append("off")
        	menu_remove_id = karamba.executeInteractive(widget, remcommand)
		
	if key == "changelanguage":
		mySetMenuConfigOption(widget, "changelanguage", 0)
		cl = ["kdialog", "--title", "", "--radiolist", ""]
		for i in range(len(locales)):
			cl.append(str(i))
			cl.append(locales_text[i])
			cl.append("off")
		menu_changelanguage_id = karamba.executeInteractive(widget, cl)	
	
	if key == "colorscheme":
		mySetMenuConfigOption(widget, "colorscheme", 0)
		cs = ["kdialog", "--title", "", "--radiolist", ""]
		for i in range(len(schemes)):
			cs.append(str(i))
			cs.append(schemes_text[i])
			cs.append("off")
		menu_colorscheme_id = karamba.executeInteractive(widget, cs)
	
	
def commandOutput(widget, pid, output):

	global menu_add_id, menu_remove_id, menu_changelanguage_id, menu_colorscheme_id
	global locale, itemlistindex, schemeindex

	if pid == menu_add_id:
		rnr = int(output)
		itemlist.append(str(rnr))
		itemlistindex = 0
		reloadData(widget)
		
	elif pid == menu_remove_id:
		rnr = int(output)
		itemlist.remove(itemlist[rnr])
		itemlistindex = 0
		reloadData(widget)
		
	elif pid == menu_changelanguage_id:
	
		locale = locales[int(output)]	
		initLocales(widget)
		reloadData(widget)
	
	elif pid == menu_colorscheme_id:
	
		schemeindex = int(output)
		updateLayout(widget)
			
	karamba.redrawWidget(widget)
	writeConfiguration(widget)
		
###############################
#
#	PARSER
#
###############################
	
#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def reloadData(widget):

 loading(widget)
 karamba.redrawWidget(widget)
 
 if len(itemlist) == 0 or itemlist[itemlistindex] == "None":
 	karamba.changeText(widget,meter_title, lc_error_emptyitemlist)
 	return -1
	
 warn = 0
	
 try:

 	fullurl = lc_url+itemlist[itemlistindex]
	
	print "Encoding: "+lc_encoding
	print "Parsing : "+fullurl		## DEBUG ##
	rawdata = urlopen(fullurl).read()
	
	## Unicode
	if lc_encoding == "utf8":
		print "Assuming UTF8"
		data = unicode(rawdata, lc_encoding)
	else:
		print "Assuming ISO"
		data = rawdata

	print rawdata	
			
	## retrieve title
	titlepattern = re.compile(lc_title_pattern)

	try:	
	
		try:
			result = titlepattern.search(data)
			title = result.group(1)	
		except:
			warn=1
			title = "???"

		if lc_encoding == "utf8":
			title = title.encode("latin1", "replace")
		else:
			print "NO UTF8"
	except:
		title = "???"
		
	karamba.redrawWidget(widget)

	
	## retrieve price
	

	pricepattern = re.compile(lc_price_pattern)
	result = pricepattern.search(data)
	
	try:
		print "HHH"
		print result.group()

		price = result.group(1)	

		if lc_encoding == "utf8":
			## UNICODE REPLACEMENTS
			ucpattern = re.compile(u"\u0142") ## Polish l
			price = ucpattern.sub("l", price)
			## Encode to Latin1
			price = price.encode("latin1" , "replace")
	
		price = striphtmltags(price)
	except:
		warn=1
		price = "??.??"
	
		
	## retrieve duration
	endpattern = re.compile(lc_end_pattern)
	auction_ended = endpattern.search(data)
	
	print auction_ended
	
	if not auction_ended == None:
		print "HERE"
		duration = lc_end_pattern
		
	else:
		try:
			durationpattern = re.compile(lc_duration_pattern)
			result = durationpattern.search(data)
		
			duration = result.group(1)
			duration = duration.encode("latin1", "replace")
		except:
			warn=1
			duration = "???"
	
		

	karamba.changeText(widget,meter_title,title)
	karamba.changeText(widget,meter_price,price)
	karamba.changeText(widget,meter_duration, duration)
	
	print "OK"
	
	karamba.redrawWidget(widget)

 except:

	title = lc_error_loading
	
 if warn == 1:
	
	warning(widget)
 

 
## Event Handling
def meterClicked(widget, meter, button):


	star = karamba.getThemeImage(widget, "star")
	down = karamba.getThemeImage(widget,"down")
	load = karamba.getThemeImage(widget,"load")
	up = karamba.getThemeImage(widget,"up")	

	if meter == up:
	
		loading(widget)
		cycleItemlist(1)
		reloadData(widget)
	
	elif meter == down:

		loading(widget)
		cycleItemlist(-1)
		reloadData(widget)	
		
	
	elif meter == load:
	
		loading(widget)
		reloadData(widget)
	
	elif meter == star:
	
		karamba.executeInteractive(widget, ["kdialog","--msgbox","MyAuction - Karamba Theme\n\nWritten by Andreas Brandmaier (andy@brandmaier.de) Munich, Germany\n\nThanks to\nTomasz Czapiewski - Polish translation\nMichele Faresin - Italian translation\nMathieu Okuyama - French Translation"])
	
	elif meter == meter_title:
	
		fullurl = lc_url+itemlist[itemlistindex]
		karamba.executeInteractive(widget,["konqueror",fullurl])
				
def widgetClicked(widget, x, y, button):

	pass		
		
	
	
## Cycle Item List  
def cycleItemlist(step):

	global itemlistindex

	itemlistindex = itemlistindex + step
	if itemlistindex >= len(itemlist):
		itemlistindex = 0
	
	if (itemlistindex < 0):
		itemlistindex = len(itemlist)-1
		

def loading(widget):
	karamba.changeText(widget,meter_title,lc_loading)
	karamba.changeText(widget,meter_price,'')
	karamba.changeText(widget,meter_duration, '')
	

def writeConfiguration(widget):

	global itemlist, locale

	try:
		itemliststr = itemlist[0]	
		for i in range(1,len(itemlist)):
        		itemliststr += '|'
			itemliststr += itemlist[i] 

	except:
		itemliststr = ''
	karamba.writeConfigEntry(widget, "itemliststring", itemliststr)		
	
	karamba.writeConfigEntry(widget, "locale", locale)
	
	karamba.writeConfigEntry(widget, "schemeindex", str(schemeindex))
		
def readConfiguration(widget):

	global itemlist, itemlistindex, locale, schemeindex
	
	# read config entry
	try:
		itemliststr =  str(karamba.readConfigEntry(widget, "itemliststring"))
		if itemliststr != "None":
			itemlist = string.split(itemliststr,'|')
		else:
			itemlist = []
	except:
		print "Itemlist not valid - starting with empty list ("+itemliststr+")"
		itemlist = []

	try:
		locale = karamba.readConfigEntry(widget, "locale")
	except:
		print "Locale not valid - using standard locale: us"
		locale = 'us'
		
	if locale == None:
		locale = 'us'
	
	try:
		schemeindex = int(karamba.readConfigEntry(widget, "schemeindex"))
	except:
		print "Schemeindex not valid"
		schemeindex = 0	
		
	try:
		itemlistindex = int(karamba.readConfigEntry(widget, "itemlistindex"))
	except:
		itemlistindex = 0

	print "Configuration read\n"
		
	
def initLocales(widget):
	
	global lc_error_loading, lc_error_emptyitemlist ,lc_url ,lc_label_title ,lc_label_price ,lc_label_duration ,lc_loading ,lc_help_cycle ,lc_help_cycleback ,lc_help_load ,lc_dialog_addauction_title ,lc_dialog_addauction_text ,lc_dialog_removeauction_title,lc_dialog_removeauction_text,lc_price_pattern ,lc_duration_pattern,lc_menu_addauction ,lc_menu_removeauction , lc_menu_changelanguage, lc_title_pattern, lc_menu_colorscheme, lc_encoding, lc_warning_ebay_changes, lc_end_pattern
	
	print "Locale: "+locale+"\n"
	
	lc_warning_ebay_changes="Warning! Ebay seemed to has changed its page structure and MyAuction is therefore unable to extract all information correctly. Upgrade to a newer version or inform the maintainers to release a new version. Thank you!"
	
	if locale == 'de':
		lc_error_loading = 'Fehler beim Laden'
		lc_error_emptyitemlist = 'Keine Auktion eingetragen'
		lc_url = 'http://cgi.ebay.de/ws/eBayISAPI.dll?ViewItem&item='
		lc_label_title = 'Auktionsname'
		lc_label_price = 'Preis'
		lc_label_duration = 'Dauer'
		lc_loading = 'Lade...'
		lc_help_cycle = 'Doppelklicken um zur nchsten Auktion zu wechseln'
		lc_help_cycleback = 'Doppelklicken um zur vorherigen Auktion zu wechseln'
		lc_help_load = 'Doppelklick um diese Auktion neu zu laden'
		lc_dialog_addauction_title = 'Auktion hinzufgen'
		lc_dialog_addauction_text = 'Bitte geben Sie die Auktionsnummer ein'
		lc_dialog_removeauction_title = 'Auktion entfernen'
		lc_dialog_removeauction_text = 'Bitte whlen Sie eine Auktionsnummer aus, die entfernt werden soll'
		lc_title_pattern = '<span class="pagetitle"><b>(.*?)<'
		lc_price_pattern = '(EUR\xa0.*?)<';
		lc_duration_pattern = 'Verbleibende Zeit:\\W*?</td><td width="100%"><b>(.*?)</b>'
		lc_end_pattern = 'Das Angebot ist beendet'
		lc_menu_addauction = 'Auktion hinzufgen'
		lc_menu_removeauction = 'Auktion entfernen'
		lc_menu_changelanguage = 'Sprache/Lndereinstellung ndern'
		lc_menu_colorscheme = 'Farbschema ndern'
		lc_encoding = 'latin1'
	elif locale == 'us':
		lc_error_loading = 'Connection failure'
		lc_error_emptyitemlist = 'Please add an auction'
		lc_url = 'http://cgi.ebay.com/ws/eBayISAPI.dll?ViewItem&item='
		lc_label_title = 'Title'
		lc_label_price = 'Current price'
		lc_label_duration = 'Time left'
		lc_loading = 'Loading...'
		lc_help_cycle = 'Doubleclick to show next auction'
		lc_help_cycleback = 'Doubleclick to show previous auction'
		lc_help_load = 'Doubleclick to reload this auction'
		lc_dialog_addauction_title = 'Add auction'
		lc_dialog_addauction_text = 'Please enter auction ID'
		lc_dialog_removeauction_title = 'Remove auction'
		lc_dialog_removeauction_text = 'Choose a auction to remove'
		lc_title_pattern = '<span class="pagetitle"><b>(.*?)<'
		lc_price_pattern = '(US \$.*?)[<\)]'
		lc_duration_pattern = 'Time left:\\W*?</td><td><b>(.*?)</b>'
		lc_end_pattern = 'Bidding has ended for this item'
		lc_menu_addauction = 'Add auction'
		lc_menu_removeauction = 'Remove auction'
		lc_menu_changelanguage = 'Change language/country'
		lc_menu_colorscheme = 'Change colorscheme'
		lc_encoding = 'latin1'	
	elif locale == 'uk':
		lc_error_loading = 'Connection failure'
		lc_error_emptyitemlist = 'Please add an auction'
		lc_url = 'http://cgi.ebay.co.uk/ws/eBayISAPI.dll?ViewItem&item='
		lc_label_title = 'Title'
		lc_label_price = 'Current price'
		lc_label_duration = 'Time left'
		lc_help_cycle = 'Doubleclick to show next auction'
		lc_help_cycleback = 'Doubleclick to show previous auction'
		lc_help_load = 'Doubleclick to reload this auction'
		lc_dialog_addauction_title = 'Add auction'
		lc_dialog_addauction_text = 'Please enter auction ID'
		lc_dialog_removeauction_title = 'Remove auction'
		lc_dialog_removeauction_text = 'Choose a auction to remove'
		lc_loading = 'Loading...'
		lc_title_pattern = '<span class="pagetitle"><b>(.*?)<'
		lc_price_pattern = '(.*?)<'
		lc_duration_pattern = 'Time left:\\W*?</td><td><b>(.*?)</b>'
		lc_end_pattern = 'Bidding has ended for this item'
		lc_menu_addauction = 'Add auction'
		lc_menu_removeauction = 'Remove auction'
		lc_menu_changelanguage = 'Change language/country'
		lc_menu_colorscheme = 'Change colorscheme'	
		lc_encoding = 'latin1'
	elif locale == 'pl':
		lc_error_loading = 'Blad polaczenia'
		lc_error_emptyitemlist = 'Prosze dodac aukcje'
		lc_url = 'http://www.allegro.pl/show_item.php?item='
		lc_label_title = 'Tytul'
		lc_label_price = 'Aktualna cena'
		lc_label_duration = 'Czas do konca'
		lc_help_cycle = 'Kliknij dwukrotnie aby zobaczyc kolejna aukcje'
		lc_help_cycleback = 'Kliknij dwukrotnie aby zobaczyc poprzednia aukcje'
		lc_help_load = 'Kliknij podwojnie aby odczytac ponownie aukcje'
		lc_dialog_addauction_title = 'Dodaj aukcje'
		lc_dialog_addauction_text = 'Prosze podac numer aukcji'
		lc_dialog_removeauction_title = 'Usun aukcje'
		lc_dialog_removeauction_text = 'Wybierz aukcje do usuniecia'
		lc_loading = 'Wczytywania...'
		lc_title_pattern = '<title>(.*?)<'
		#lc_price_pattern = 'Kup Teraz</span>:</td><td class=it-td valign=top><b>(.*?)</b>'
		lc_price_pattern = 'Aktualna cena:</td>\\W*?<td class=it-td valign=top><b>\\W*?(.*?)</b>'
		lc_duration_pattern = 'Do ko.ca:</td>\\W*?<td class=it-td valign=top><b>(.*?)</b>'
		lc_end_pattern = 'aokdasdasd- not implemented yet -asidjisjfi'
		lc_menu_addauction = 'Dodaj aukcje'
		lc_menu_removeauction = 'Usun aukcje'
		lc_menu_changelanguage = 'Zmien jezyk/kraj'
		lc_menu_colorscheme = 'Zmien schemat kolorow'
		lc_encoding = 'utf8'	
	elif locale == 'it':
		lc_error_loading = 'Connessione Fallita'
		lc_error_emptyitemlist = 'Per favore, aggiungi un`inserzione'
		lc_url = 'http://cgi.ebay.it/ws/eBayISAPI.dll?ViewItem&item='
		lc_label_title = 'Descrizione'
		lc_label_price = 'Prezzo attuale'
		lc_label_duration = 'Tempo rimasto'
		lc_help_cycle = 'Doppio click per visualizzare l`inserzione successiva'
		lc_help_cycleback = 'Doppio click per visualizzare l`inserzione precedente'
		lc_help_load = 'Doppio click per aggiornare l`inserzione'
		lc_dialog_addauction_title = 'Aggiungi un`inserzione'
		lc_dialog_addauction_text = 'Per favore, inserisci l`ID dell`inserzione'
		lc_dialog_removeauction_title = 'Rimuovi un`inserzione'
		lc_dialog_removeauction_text = 'Scegli l`inserzione da rimuovere'
		lc_loading = 'Sto caricando...'
		lc_title_pattern = '<span class="pagetitle"><b>(.*?)<'
		lc_price_pattern = '(EUR\\W.*?)<';
		lc_duration_pattern = 'Tempo rimasto:\\W*?</td><td><b>(.*?)</b>'
		lc_end_pattern = 'Le offerte per questa inserzione sono terminate'
		lc_menu_addauction = 'Aggiungi un`inserzione'
		lc_menu_removeauction = 'Rimuovi un`inserzione'
		lc_menu_changelanguage = 'Cambia la Lingua/Paese'
		lc_menu_colorscheme = 'Cambia lo schema colore'
		lc_encoding = 'latin1'	
	elif locale == 'fr':
		lc_error_loading = 'Echec de connexion'
		lc_error_emptyitemlist = 'Ajouter une offre'
		lc_url = 'http://cgi.ebay.fr/ws/eBayISAPI.dll?ViewItem&item='
		lc_label_title = 'Titre'
		lc_label_price = 'Prix actuel'
		lc_label_duration = 'Temps restant'
		lc_loading = 'Chargement...'
		lc_help_cycle = 'Clicker pour voir l\'offre suivante'
		lc_help_cycleback = 'Clicker pour voir l\'offre prcdente'
		lc_help_load = 'Clicker pour recharger l\'offre'
		lc_dialog_addauction_title = 'Ajouter une offre'
		lc_dialog_addauction_text = 'Entrer l\'ID de l\'offre'
		lc_dialog_removeauction_title = 'Supprimer l\'offre'
		lc_dialog_removeauction_text = 'Choisisser l\'offre  supprimer'
		lc_title_pattern = '<span class="pagetitle"><b>(.*?)<'
		lc_price_pattern = '>(.*?\\WEUR)<';
		lc_duration_pattern = 'Temps restant\\W*?</td><td><b>(.*?)</b>'
		lc_end_pattern = 'Les enchres sur cet objet sont termines'
		lc_menu_addauction = 'Ajouter une offre'
		lc_menu_removeauction = 'Supprimer une offre'
		lc_menu_changelanguage = 'Changer de langue/pays'
		lc_menu_colorscheme = 'Changer de thme'
		lc_encoding = 'latin1'		
	else:
		lc_error_loading = 'Locale not supported!'
		lc_url = 'Locale not supported!'
		lc_label_title = 'Locale not supported!'
		lc_label_price = 'Locale not supported!'
		lc_label_duration = 'Locale not supported!'
		lc_help_cycle = 'Locale not supported!'	
		lc_dialog_addauction_title = ''
		lc_dialog_addauction_text = ''
		lc_loading = ''
		lc_price_pattern = ''
		lc_duration_pattern = ''
		lc_title_pattern = ''
		lc_menu_addauction = 'Add auction'
		lc_menu_removeauction = 'Remove auction'
		lc_menu_changelanguage = 'Change language/country'
		lc_menu_colorscheme = ''
		lc_encoding = 'iso-8859-1'
		
	## update text meters
	karamba.changeText(widget,label_title,lc_label_title)
	karamba.changeText(widget,label_price,lc_label_price)
	karamba.changeText(widget,label_duration,lc_label_duration)
		

## layout

def createLayout(widget):

	global schemes, scheme
	global label_title, label_price, label_duration
	global meter_title, meter_price, meter_duration
	
	cur_scheme = schemes[schemeindex]
	
	r1 = cur_scheme[0][0]
	g1 = cur_scheme[0][1]
	b1 = cur_scheme[0][2]
	r2 = cur_scheme[1][0]
	g2 = cur_scheme[1][1]
	b2 = cur_scheme[1][2]
	
	
	## create labels
	label_title    = createTextLabel(widget, 45, 15, 11, r1,g1,b1)
	label_price    = createTextLabel(widget, 45, 40, 11, r1,g1,b1)
	label_duration = createTextLabel(widget, 45, 67, 11, r1,g1,b1)
	
	## create meters
	meter_title    = createTextLabel(widget, 45, 27, 9 , r2,g2,b2)
	#meter_title    = createRichTextLabel(widget, 43, 24)
	meter_price    = createTextLabel(widget, 45, 49, 14, r2,g2,b2)
	meter_duration = createTextLabel(widget, 45, 78, 11, r2,g2,b2)

def updateLayout(widget):

	cur_scheme = schemes[schemeindex]
	
	r1 = cur_scheme[0][0]
	g1 = cur_scheme[0][1]
	b1 = cur_scheme[0][2]
	r2 = cur_scheme[1][0]
	g2 = cur_scheme[1][1]
	b2 = cur_scheme[1][2]
	
	karamba.changeTextColor(widget, label_title, r1, g1, b1)
	karamba.changeTextColor(widget, label_price, r1, g1, b1)
	karamba.changeTextColor(widget, label_duration, r1, g1, b1)
	karamba.changeTextColor(widget, meter_title, r2, g2, b2)
	karamba.changeTextColor(widget, meter_price, r2, g2, b2)
	karamba.changeTextColor(widget, meter_duration, r2, g2, b2)
	
	karamba.redrawWidget(widget)
	
	
def createTextLabel(widget, x, y, size, r, g, b):

	w = 200-x
	h = size+1
	
	value = karamba.createText(widget, x, y, w, h, '')
	karamba.changeTextColor(widget, value, r, g, b)
	karamba.changeTextSize(widget, value, size)
	
	return value
	
def createRichTextLabel(widget, x, y):

	#width= 200
	richtext = karamba.createRichText(widget,'',False)
	#return createTextLabel(widget,x,y, size,r,g,b)	
	karamba.moveRichText(widget, richtext, x, y)
	#karamba.setRichTextWidth(widget, richtext, width)
	return richtext

def striphtmltags(html):

	pattern = re.compile("<(.*?)>")
	html = pattern.sub("",html)

	return html
		
	
def warning(widget):

	karamba.executeInteractive(widget, ["kdialog","--msgbox",lc_warning_ebay_changes])
	
# and now...

# This will be printed when the widget loads.
print "Loaded MyAuction extension!"

 
